--- ../../../../gcc-clean/src/gcc/config/darwin.c	Sat Jan 25 15:19:38 2003
+++ ./darwin.c	Sun Feb  2 22:19:53 2003
@@ -124,8 +124,9 @@ machopic_classify_ident (ident)
   else if (name[1] == 'd' || name[1] == 't')
     {
       char *new_name;
-      new_name = (char *)alloca (strlen (name) + 1);
-      strcpy (new_name, name);
+      int name_len = strlen (name);
+      new_name = (char *)alloca (name_len + 1);
+      memcpy (new_name, name, name_len + 1);
       new_name[1] = (name[1] == 'd') ? 'D' : 'T';
       if (maybe_get_identifier (new_name) != NULL)
 	return  (name[1] == 'd') ? MACHOPIC_DEFINED_DATA
@@ -295,19 +296,24 @@ machopic_non_lazy_ptr_name (name)
   {
     char *buffer;
     tree ptr_name;
+    int len_name = strlen (name);
 
-    buffer = alloca (strlen (name) + 20);
+    buffer = alloca ( len_name + 20);
 
-    strcpy (buffer, "&L");
+    memcpy (buffer, "&L", 2);
     if (name[0] == '*')
-      strcat (buffer, name+1);
+      {
+        memcpy (buffer + 2, name + 1, len_name);
+        len_name -= 1;
+      }
     else
       {
-	strcat (buffer, "_");
-	strcat (buffer, name);
+	memcpy (buffer + 2, "_", 1);
+	memcpy (buffer + 3, name, len_name + 1);
+        len_name += 1;
       }
       
-    strcat (buffer, "$non_lazy_ptr");
+    memcpy (buffer + 2 + len_name, "$non_lazy_ptr", strlen ("$non_lazy_ptr") + 1);
     ptr_name = get_identifier (buffer);
 
     machopic_non_lazy_pointers 
@@ -354,27 +360,37 @@ machopic_stub_name (name)
     char *buffer;
     tree ptr_name;
     int needs_quotes = name_needs_quotes (name);
+    int len=0;
+    int name_len = strlen (name);
 
-    buffer = alloca (strlen (name) + 20);
+    buffer = alloca (name_len + 20);
 
     if (needs_quotes)
-      strcpy (buffer, "&\"L");
+      {
+        len = 3;
+        memcpy (buffer, "&\"L", len);
+      }
     else
-      strcpy (buffer, "&L");
+      {
+        len = 2;
+        memcpy (buffer, "&L", len);
+      }
     if (name[0] == '*')
       {
-	strcat (buffer, name+1);
+        len += name_len-1;
+	memcpy (buffer+len, name+1, name_len);
       }
     else
       {
-	strcat (buffer, "_");
-	strcat (buffer, name);
+	memcpy (buffer + len, "_", 1);
+	memcpy (buffer + len + 1, name, name_len);
+        len += name_len+1;
       }
 
     if (needs_quotes)
-      strcat (buffer, "$stub\"");
+      memcpy (buffer + len, "$stub\"", 7);
     else
-      strcat (buffer, "$stub");
+      memcpy (buffer + len, "$stub", 6);
     ptr_name = get_identifier (buffer);
 
     machopic_stubs = tree_cons (ptr_name, ident, machopic_stubs);
